# A simple PoC for equipment tracking

- Should run in any terminal (cmd, bash etc.), even old hardware.
- Enables simple handling by keeping items in storage and rented out.
- Very simple user interface which can be operated without a mouse.
- Extensible through component-based storage.

## Running

To run the application the user needs to have
[`Rust`](https://www.rust-lang.org/) installed. Instructions can be found
[here](https://www.rust-lang.org/tools/install).

When `Rust` is installed, simply run:

```bash
cargo run
```

### Using test-data

To run the application with test-data, simply copy `test-data.json` to
`data.json`.

```bash
cp test-data.json data.json
```

## Todo

- [X] Basic logging and user interface setup
- [X] Store items with metadata and location
- [X] Rent items to users
- [X] Return items from users
- [X] Add instructions and test data
- [X] Store state to a file (simple persistent storage)
- [ ] Store event-sourced state to CouchDB (complex persistent storage)
	- [ ] Setup connection to CouchDB
	- [ ] Upload state changes to CouchDB (use `FlaggedStorage` from `specs`)
	- [ ] Reassemble state based on change events from CouchDB
